## ats2-lang 0.4.2

=== src/Makefile ===
#
#
# This Makefile is automatically generated
# from executing the following command-line:
#
# make -f Makefile.gen
#
#

######
#
CC=gcc
CCOMP=$(CC)
#
export ATSCCOMP=$(CC)
#
######

ATSCC=$(ATSHOME)/bin/atscc
ATSOPT=$(ATSHOME)/bin/atsopt

######

CFLAGS=-g
CFLAGS=-g -O
CFLAGS=-g -O2

######
#
GCFLAG=
#
# GCFLAG=-D_ATS_NGC
# GCFLAG=-D_ATS_GCBDW
# GCFLAG=-D_ATS_GCATS
#
######
#
# Bootstrapping:
#
# [gmpknd] for CBOOTgmp
# [intknd] for CBOOTint
#
#C3NSTRINTKND=gmpknd
#C3NSTRINTKND=intknd
#
######
#
DATSCC=-DATS \
C3NSTRINTKND=$(C3NSTRINTKND)
#
######

LIBATS=-lats

######
#
# HX: no [gmp] 
ifeq ($(C3NSTRINTKND),intknd)
LIBGMP=
endif
#
# HX: [gmp] needed
ifeq ($(C3NSTRINTKND),gmpknd)
LIBGMP=-lgmp
endif
#
######

SOURCES := \
  pats_params.hats \
  pats_error.sats \
  pats_error.dats \
  pats_intinf.sats \
  pats_intinf.dats \
  pats_intinf_int.hats \
  pats_intinf_gmp.hats \
  pats_counter.sats \
  pats_counter.dats \
  pats_utils.sats \
  pats_utils.dats \
  pats_global.sats \
  pats_global.dats \
  pats_basics.sats \
  pats_basics.dats \
  pats_basics.hats \
  pats_comarg.sats \
  pats_comarg.dats \
  pats_stamp.sats \
  pats_stamp.dats \
  pats_symbol.sats \
  pats_symbol.dats \
  pats_filename.sats \
  pats_filename.dats \
  pats_filename_reloc.dats \
  pats_location.sats \
  pats_location.dats \
  pats_location.cats \
  pats_jsonize.sats \
  pats_jsonize.dats \
  pats_errmsg.sats \
  pats_errmsg.dats \
  pats_reader.sats \
  pats_reader.dats \
  pats_reader.cats \
  pats_lexbuf.sats \
  pats_lexbuf.dats \
  pats_lexbuf.cats \
  pats_lexing.sats \
  pats_lexing.dats \
  pats_lexing.cats \
  pats_lexing_print.dats \
  pats_lexing_error.dats \
  pats_lexing_token.dats \
  pats_label.sats \
  pats_label.dats \
  pats_effect.sats \
  pats_effect.dats \
  pats_fixity.sats \
  pats_fixity_prec.dats \
  pats_fixity_fxty.dats \
  pats_syntax.sats \
  pats_syntax.dats \
  pats_syntax_print.dats \
  pats_depgen.sats \
  pats_depgen.dats \
  pats_taggen.sats \
  pats_taggen.dats \
  pats_tokbuf.sats \
  pats_tokbuf.dats \
  pats_tokbuf.cats \
  pats_parsing.sats \
  pats_parsing.dats \
  pats_parsing_error.dats \
  pats_parsing_util.dats \
  pats_parsing_kwds.dats \
  pats_parsing_base.dats \
  pats_parsing_e0xp.dats \
  pats_parsing_sort.dats \
  pats_parsing_staexp.dats \
  pats_parsing_p0at.dats \
  pats_parsing_dynexp.dats \
  pats_parsing_decl.dats \
  pats_parsing_toplevel.dats \
  pats_symmap.sats \
  pats_symmap.dats \
  pats_symmap_avltree.hats \
  pats_symmap_htlinprb.hats \
  pats_symenv.sats \
  pats_symenv.dats \
  pats_staexp1.sats \
  pats_staexp1.dats \
  pats_staexp1_print.dats \
  pats_dynexp1.sats \
  pats_dynexp1.dats \
  pats_dynexp1_print.dats \
  pats_trans1.sats \
  pats_trans1_env.sats \
  pats_trans1_env.dats \
  pats_e1xpval.sats \
  pats_e1xpval.dats \
  pats_e1xpval_error.dats \
  pats_trans1_error.dats \
  pats_trans1_e0xp.dats \
  pats_trans1_effect.dats \
  pats_trans1_sort.dats \
  pats_trans1_staexp.dats \
  pats_trans1_p0at.dats \
  pats_trans1_syndef.dats \
  pats_trans1_dynexp.dats \
  pats_trans1_decl.dats \
  pats_staexp2.sats \
  pats_staexp2.dats \
  pats_stacst2.sats \
  pats_stacst2.dats \
  pats_staexp2_print.dats \
  pats_staexp2_pprint.dats \
  pats_staexp2_sort.dats \
  pats_staexp2_scst.dats \
  pats_staexp2_svar.dats \
  pats_staexp2_svvar.dats \
  pats_staexp2_hole.dats \
  pats_staexp2_ctxt.dats \
  pats_staexp2_dcon.dats \
  pats_staexp2_skexp.dats \
  pats_staexp2_szexp.dats \
  pats_staexp2_util.sats \
  pats_staexp2_util1.dats \
  pats_staexp2_util2.dats \
  pats_staexp2_util3.dats \
  pats_staexp2_error.sats \
  pats_staexp2_error.dats \
  pats_staexp2_solve.sats \
  pats_staexp2_solve.dats \
  pats_patcst2.sats \
  pats_patcst2.dats \
  pats_dynexp2.sats \
  pats_dynexp2.dats \
  pats_dyncst2.sats \
  pats_dyncst2.dats \
  pats_dynexp2_print.dats \
  pats_dynexp2_dcst.dats \
  pats_dynexp2_dvar.dats \
  pats_dynexp2_dmac.dats \
  pats_dynexp2_util.dats \
  pats_staexp2_appenv.hats \
  pats_dynexp2_appenv.hats \
  pats_dynexp2_mapgen.dats \
  pats_trans2.sats \
  pats_namespace.sats \
  pats_namespace.dats \
  pats_trans2_env.sats \
  pats_trans2_env.dats \
  pats_trans2_error.dats \
  pats_trans2_sort.dats \
  pats_trans2_staexp.dats \
  pats_trans2_p1at.dats \
  pats_trans2_dynexp.dats \
  pats_trans2_impdec.dats \
  pats_trans2_decl.dats \
  pats_codegen2.sats \
  pats_codegen2.dats \
  pats_codegen2_util.dats \
  pats_codegen2_absrec.dats \
  pats_codegen2_datype.dats \
  pats_codegen2_fprint.dats \
  pats_jsonize_synent2.sats \
  pats_jsonize_synent2.dats \
  pats_dynexp3.sats \
  pats_dynexp3.dats \
  pats_dynexp3_print.dats \
  pats_trans3.sats \
  pats_trans3_error.dats \
  pats_trans3_util.dats \
  pats_trans3_env.sats \
  pats_trans3_env.dats \
  pats_trans3_env_print.dats \
  pats_trans3_env_scst.dats \
  pats_trans3_env_svar.dats \
  pats_trans3_env_termet.dats \
  pats_trans3_env_effect.dats \
  pats_trans3_env_dvar.dats \
  pats_trans3_env_lamlp.dats \
  pats_trans3_env_pfman.dats \
  pats_trans3_env_lstate.dats \
  pats_dmacro2.sats \
  pats_dmacro2.dats \
  pats_dmacro2_print.dats \
  pats_dmacro2_eval0.dats \
  pats_dmacro2_eval1.dats \
  pats_trans3_p2at.dats \
  pats_trans3_patcon.dats \
  pats_trans3_syncst.dats \
  pats_trans3_dynexp_up.dats \
  pats_trans3_dynexp_dn.dats \
  pats_trans3_appsym.dats \
  pats_trans3_caseof.dats \
  pats_trans3_selab.dats \
  pats_trans3_ptrof.dats \
  pats_trans3_viewat.dats \
  pats_trans3_deref.dats \
  pats_trans3_assgn.dats \
  pats_trans3_xchng.dats \
  pats_trans3_lvalres.dats \
  pats_trans3_fldfrat.dats \
  pats_trans3_looping.dats \
  pats_trans3_decl.dats \
  pats_lintprgm.sats \
  pats_lintprgm.dats \
  pats_lintprgm_print.dats \
  pats_lintprgm_myint.cats \
  pats_lintprgm_myint.dats \
  pats_lintprgm_solve.dats \
  pats_constraint3.sats \
  pats_constraint3.dats \
  pats_constraint3_print.dats \
  pats_constraint3_appenv.hats \
  pats_constraint3_mapgen.dats \
  pats_constraint3_jsonize.dats \
  pats_constraint3_init.dats \
  pats_constraint3_simplify.dats \
  pats_constraint3_icnstr.dats \
  pats_constraint3_solve.dats \
  pats_histaexp.sats \
  pats_histaexp.dats \
  pats_histaexp_print.dats \
  pats_histaexp_funlab.dats \
  pats_hidynexp.sats \
  pats_hidynexp.dats \
  pats_hidynexp_print.dats \
  pats_hidynexp_util.dats \
  pats_typerase.sats \
  pats_typerase_error.dats \
  pats_typerase_staexp.dats \
  pats_typerase_dynexp.dats \
  pats_typerase_decl.dats \
  pats_ccomp.sats \
  pats_ccomp.dats \
  pats_ccomp_print.dats \
  pats_ccomp_hitype.dats \
  pats_ccomp_tmplab.dats \
  pats_ccomp_tmpvar.dats \
  pats_ccomp_d2env.dats \
  pats_ccomp_funlab.dats \
  pats_ccomp_funent.dats \
  pats_ccomp_util.dats \
  pats_ccomp_ccompenv.dats \
  pats_ccomp_instrseq.dats \
  pats_ccomp_hipat.dats \
  pats_ccomp_dynexp.dats \
  pats_ccomp_caseof.dats \
  pats_ccomp_claulst.dats \
  pats_ccomp_lazyeval.dats \
  pats_ccomp_trywith.dats \
  pats_ccomp_looping.dats \
  pats_ccomp_decl.dats \
  pats_ccomp_subst.dats \
  pats_ccomp_environ.dats \
  pats_ccomp_template.dats \
  pats_ccomp_emit.dats \
  pats_ccomp_emit2.dats \
  pats_ccomp_emit3.dats \
  pats_ccomp_main.dats \


SOURCESsta := $(filter %.sats, $(SOURCES))
SOURCESdyn := $(filter %.dats, $(SOURCES))

######

TARGETS := \
  pats_error_sats.c \
  pats_error_dats.c \
  pats_intinf_sats.c \
  pats_intinf_dats.c \
  pats_counter_sats.c \
  pats_counter_dats.c \
  pats_utils_sats.c \
  pats_utils_dats.c \
  pats_global_sats.c \
  pats_global_dats.c \
  pats_basics_sats.c \
  pats_basics_dats.c \
  pats_comarg_sats.c \
  pats_comarg_dats.c \
  pats_stamp_sats.c \
  pats_stamp_dats.c \
  pats_symbol_sats.c \
  pats_symbol_dats.c \
  pats_filename_sats.c \
  pats_filename_dats.c \
  pats_filename_reloc_dats.c \
  pats_location_sats.c \
  pats_location_dats.c \
  pats_jsonize_sats.c \
  pats_jsonize_dats.c \
  pats_errmsg_sats.c \
  pats_errmsg_dats.c \
  pats_reader_sats.c \
  pats_reader_dats.c \
  pats_lexbuf_sats.c \
  pats_lexbuf_dats.c \
  pats_lexing_sats.c \
  pats_lexing_dats.c \
  pats_lexing_print_dats.c \
  pats_lexing_error_dats.c \
  pats_lexing_token_dats.c \
  pats_label_sats.c \
  pats_label_dats.c \
  pats_effect_sats.c \
  pats_effect_dats.c \
  pats_fixity_sats.c \
  pats_fixity_prec_dats.c \
  pats_fixity_fxty_dats.c \
  pats_syntax_sats.c \
  pats_syntax_dats.c \
  pats_syntax_print_dats.c \
  pats_depgen_sats.c \
  pats_depgen_dats.c \
  pats_taggen_sats.c \
  pats_taggen_dats.c \
  pats_tokbuf_sats.c \
  pats_tokbuf_dats.c \
  pats_parsing_sats.c \
  pats_parsing_dats.c \
  pats_parsing_error_dats.c \
  pats_parsing_util_dats.c \
  pats_parsing_kwds_dats.c \
  pats_parsing_base_dats.c \
  pats_parsing_e0xp_dats.c \
  pats_parsing_sort_dats.c \
  pats_parsing_staexp_dats.c \
  pats_parsing_p0at_dats.c \
  pats_parsing_dynexp_dats.c \
  pats_parsing_decl_dats.c \
  pats_parsing_toplevel_dats.c \
  pats_symmap_sats.c \
  pats_symmap_dats.c \
  pats_symenv_sats.c \
  pats_symenv_dats.c \
  pats_staexp1_sats.c \
  pats_staexp1_dats.c \
  pats_staexp1_print_dats.c \
  pats_dynexp1_sats.c \
  pats_dynexp1_dats.c \
  pats_dynexp1_print_dats.c \
  pats_trans1_sats.c \
  pats_trans1_env_sats.c \
  pats_trans1_env_dats.c \
  pats_e1xpval_sats.c \
  pats_e1xpval_dats.c \
  pats_e1xpval_error_dats.c \
  pats_trans1_error_dats.c \
  pats_trans1_e0xp_dats.c \
  pats_trans1_effect_dats.c \
  pats_trans1_sort_dats.c \
  pats_trans1_staexp_dats.c \
  pats_trans1_p0at_dats.c \
  pats_trans1_syndef_dats.c \
  pats_trans1_dynexp_dats.c \
  pats_trans1_decl_dats.c \
  pats_staexp2_sats.c \
  pats_staexp2_dats.c \
  pats_stacst2_sats.c \
  pats_stacst2_dats.c \
  pats_staexp2_print_dats.c \
  pats_staexp2_pprint_dats.c \
  pats_staexp2_sort_dats.c \
  pats_staexp2_scst_dats.c \
  pats_staexp2_svar_dats.c \
  pats_staexp2_svvar_dats.c \
  pats_staexp2_hole_dats.c \
  pats_staexp2_ctxt_dats.c \
  pats_staexp2_dcon_dats.c \
  pats_staexp2_skexp_dats.c \
  pats_staexp2_szexp_dats.c \
  pats_staexp2_util_sats.c \
  pats_staexp2_util1_dats.c \
  pats_staexp2_util2_dats.c \
  pats_staexp2_util3_dats.c \
  pats_staexp2_error_sats.c \
  pats_staexp2_error_dats.c \
  pats_staexp2_solve_sats.c \
  pats_staexp2_solve_dats.c \
  pats_patcst2_sats.c \
  pats_patcst2_dats.c \
  pats_dynexp2_sats.c \
  pats_dynexp2_dats.c \
  pats_dyncst2_sats.c \
  pats_dyncst2_dats.c \
  pats_dynexp2_print_dats.c \
  pats_dynexp2_dcst_dats.c \
  pats_dynexp2_dvar_dats.c \
  pats_dynexp2_dmac_dats.c \
  pats_dynexp2_util_dats.c \
  pats_dynexp2_mapgen_dats.c \
  pats_trans2_sats.c \
  pats_namespace_sats.c \
  pats_namespace_dats.c \
  pats_trans2_env_sats.c \
  pats_trans2_env_dats.c \
  pats_trans2_error_dats.c \
  pats_trans2_sort_dats.c \
  pats_trans2_staexp_dats.c \
  pats_trans2_p1at_dats.c \
  pats_trans2_dynexp_dats.c \
  pats_trans2_impdec_dats.c \
  pats_trans2_decl_dats.c \
  pats_codegen2_sats.c \
  pats_codegen2_dats.c \
  pats_codegen2_util_dats.c \
  pats_codegen2_absrec_dats.c \
  pats_codegen2_datype_dats.c \
  pats_codegen2_fprint_dats.c \
  pats_jsonize_synent2_sats.c \
  pats_jsonize_synent2_dats.c \
  pats_dynexp3_sats.c \
  pats_dynexp3_dats.c \
  pats_dynexp3_print_dats.c \
  pats_trans3_sats.c \
  pats_trans3_error_dats.c \
  pats_trans3_util_dats.c \
  pats_trans3_env_sats.c \
  pats_trans3_env_dats.c \
  pats_trans3_env_print_dats.c \
  pats_trans3_env_scst_dats.c \
  pats_trans3_env_svar_dats.c \
  pats_trans3_env_termet_dats.c \
  pats_trans3_env_effect_dats.c \
  pats_trans3_env_dvar_dats.c \
  pats_trans3_env_lamlp_dats.c \
  pats_trans3_env_pfman_dats.c \
  pats_trans3_env_lstate_dats.c \
  pats_dmacro2_sats.c \
  pats_dmacro2_dats.c \
  pats_dmacro2_print_dats.c \
  pats_dmacro2_eval0_dats.c \
  pats_dmacro2_eval1_dats.c \
  pats_trans3_p2at_dats.c \
  pats_trans3_patcon_dats.c \
  pats_trans3_syncst_dats.c \
  pats_trans3_dynexp_up_dats.c \
  pats_trans3_dynexp_dn_dats.c \
  pats_trans3_appsym_dats.c \

=== contrib/ATS-extsolve-smt2/Makefile ===
##
## ATS-extsolve-smt2:
## Solving ATS-constraints with SMT2
##

######
##
## Author: Hongwei Xi
## Authoremail: gmhwxiATgmailDOTcom
##
## Start time: May, 2015
##
######

CC=gcc

######

ifdef \
PATSHOME
PATSHOMEQ="$(PATSHOME)"
else
ifdef ATSHOME
  PATSHOMEQ="$(ATSHOME)"
else
  PATSHOMEQ="/usr/local/lib/ats2-postiats"
endif
endif

######

PATSCC=$(PATSHOMEQ)/bin/patscc
PATSOPT=$(PATSHOMEQ)/bin/patsopt

######

all::

######
#
CFLAGS :=
CFLAGS += -DATS_MEMALLOC_LIBC
#
CFLAGS2 :=
CFLAGS2 +=-DATS_MEMALLOC_LIBC
CFLAGS2 +=\
-I${PATSHOMEQ}/contrib/atscntrb
#
CFLAGS2 += \
$(shell pkg-config --cflags json-c)
#
######

EXTRA_CFLAGS :=

######

PATSCC2 = \
$(PATSCC) \
$(CFLAGS2) $(EXTRA_CFLAGS)

######

LDFLAGS :=
LDFLAGS += \
$(shell pkg-config --libs json-c)
LDFLAGS +=-lgc

######

INCLUDE :=
INCLUDE += -I$(PATSHOMEQ)
INCLUDE += -I$(PATSHOMEQ)/ccomp/runtime

######

PATSOLVE=./ATS-extsolve

######

SOURCES_SATS= \
$(PATSOLVE)/SATS/patsolve_cnstrnt.sats \
$(PATSOLVE)/SATS/patsolve_parsing.sats \

######

SOURCES_CATS= \
$(PATSOLVE)/CATS/patsolve_cnstrnt_dats.c \
$(PATSOLVE)/CATS/patsolve_parsing_dats.c \

######

SOURCES_DATS :=
SOURCES_DATS += patsolve_smt2_main.dats
SOURCES_DATS += patsolve_smt2_mylib.dats
SOURCES_DATS += patsolve_smt2_commarg.dats
SOURCES_DATS += patsolve_smt2_solving.dats

######

TARGETS_DATS_O = \
$(patsubst %.dats, %_dats.o, $(SOURCES_DATS))

######
#
all:: ; \
$(MAKE) -C ATS-extsolve DATS_C
#
all:: \
bin_patsolve_smt2
bin_patsolve_smt2: \
$(TARGETS_DATS_O); \
$(PATSCC2) -O2 -o bin/patsolve_smt2 \
$(SOURCES_SATS) $(SOURCES_CATS) $(TARGETS_DATS_O) $(LDFLAGS)
#
cleanall:: ; $(RMF) bin/patsolve_smt2
#
######
#
npm:: all
npm:: ; $(CPF) patsolve_smt2_*_dats.c npm/CATS/.
npm:: ; $(CPF) patsolve_parsing_sats.c npm/CATS/.
npm:: ; $(CPF) patsolve_cnstrnt_sats.c npm/CATS/.
#
######

%_dats.o: DATS/%.dats; $(PATSCC2) -c $<

######

testall:: all
testall:: cleanall

######

CPF=cp -f
RMF=rm -f
MAKE=make

######

clean:: ; $(RMF) *~
clean:: ; $(RMF) *_?ats.o
clean:: ; $(RMF) *_?ats.c

######

cleanall:: clean
cleanall:: ; $(RMF) ./npm/CATS/patsolve_smt2_*_dats.c
cleanall:: ; $(RMF) ./npm/CATS/patsolve_parsing_sats.c
cleanall:: ; $(RMF) ./npm/CATS/patsolve_cnstrnt_sats.c

######

## end of [Makefile] ##

=== contrib/ATS-extsolve-z3/Makefile ===
##
## ATS-extsolve-z3:
## Solving ATS-constraints with Z3
##

######
##
## Author: Hongwei Xi
## Authoremail: gmhwxiATgmailDOTcom
##
## Start time: May, 2015
##
######

CC=gcc

######

ifdef \
PATSHOME
PATSHOMEQ="$(PATSHOME)"
else
ifdef ATSHOME
  PATSHOMEQ="$(ATSHOME)"
else
  PATSHOMEQ="/usr/local/lib/ats2-postiats"
endif
endif

######

PATSCC=$(PATSHOMEQ)/bin/patscc
PATSOPT=$(PATSHOMEQ)/bin/patsopt

######

all::

######
#
CFLAGS :=
CFLAGS += -DATS_MEMALLOC_LIBC
#
CFLAGS2 :=
CFLAGS2 +=-DATS_MEMALLOC_LIBC
CFLAGS2 +=\
-I${PATSHOMEQ}/contrib/atscntrb
CFLAGS2 += \
$(shell pkg-config --cflags json-c)
#
######

EXTRA_CFLAGS :=

######

PATSCC2 = \
$(PATSCC) \
$(CFLAGS2) $(EXTRA_CFLAGS)

######
#
LDFLAGS :=
LDFLAGS += \
$(shell pkg-config --libs json-c)
#
LDFLAGS +=-lz3
LDFLAGS +=-lgc
#
######

INCLUDE :=
INCLUDE += -I$(PATSHOMEQ)
INCLUDE += -I$(PATSHOMEQ)/ccomp/runtime

######

PATSOLVE=./ATS-extsolve

######

SOURCES_SATS= \
$(PATSOLVE)/SATS/patsolve_cnstrnt.sats \
$(PATSOLVE)/SATS/patsolve_parsing.sats \

######

SOURCES_CATS= \
$(PATSOLVE)/CATS/patsolve_cnstrnt_dats.c \
$(PATSOLVE)/CATS/patsolve_parsing_dats.c \

######

SOURCES_DATS :=
SOURCES_DATS += patsolve_z3_main.dats
SOURCES_DATS += patsolve_z3_mylib.dats
SOURCES_DATS += patsolve_z3_commarg.dats
SOURCES_DATS += patsolve_z3_solving.dats

######

TARGETS_DATS_O = \
$(patsubst %.dats, %_dats.o, $(SOURCES_DATS))

######
#
all:: ; \
$(MAKE) -C ATS-extsolve DATS_C
#
all:: \
bin_patsolve_z3
bin_patsolve_z3: \
$(TARGETS_DATS_O); \
$(PATSCC2) -O2 -o bin/patsolve_z3 \
$(SOURCES_SATS) $(SOURCES_CATS) $(TARGETS_DATS_O) $(LDFLAGS)
#
cleanall:: ; $(RMF) bin/patsolve_z3
#
######
#
npm:: all
npm:: ; $(CPF) patsolve_z3_*_dats.c npm/CATS/.
npm:: ; $(CPF) patsolve_parsing_sats.c npm/CATS/.
npm:: ; $(CPF) patsolve_cnstrnt_sats.c npm/CATS/.
#
######

%_dats.o: DATS/%.dats; $(PATSCC2) -c $<

######

testall:: all
testall:: cleanall

######

CPF=cp -f
RMF=rm -f
MAKE=make

######

clean:: ; $(RMF) *~
clean:: ; $(RMF) *_?ats.o
clean:: ; $(RMF) *_?ats.c

######
#
cleanall:: clean
#
cleanall:: ; $(RMF) ./npm/CATS/patsolve_z3_*_dats.c
cleanall:: ; $(RMF) ./npm/CATS/patsolve_parsing_sats.c
cleanall:: ; $(RMF) ./npm/CATS/patsolve_cnstrnt_sats.c
#
######

## end of [Makefile] ##

=== contrib/ATS-extsolve/Makefile ===
##
## ATS-extsolve:
## For solving ATS-constraints
## with external SMT-solvers
##

######
##
## Author: Hongwei Xi
## Authoremail: gmhwxiATgmailDOTcom
##
## Start time: May, 2015
##
######

CC=gcc

######

ifdef \
PATSHOME
PATSHOMEQ="$(PATSHOME)"
else
ifdef ATSHOME
  PATSHOMEQ="$(ATSHOME)"
else
  PATSHOMEQ="/usr/local/lib/ats2-postiats"
endif
endif

######

PATSCC=$(PATSHOMEQ)/bin/patscc
PATSOPT=$(PATSHOMEQ)/bin/patsopt

######

all::

######
#
CFLAGS :=
CFLAGS += -DATS_MEMALLOC_LIBC
#
CFLAGS2 :=
#
CFLAGS2 += \
-I${PATSHOMEQ}/contrib/atscntrb
CFLAGS2 += \
$(shell pkg-config --cflags json-c)
#
######

LDFLAGS :=
LDFLAGS += $(shell pkg-config --libs json-c)

######

EXTRAFLAGS :=

######
#
INCLUDE :=
INCLUDE += -I$(PATSHOMEQ)
INCLUDE += -I$(PATSHOMEQ)/ccomp/runtime
#
######

SOURCES_SATS= \
  patsolve_cnstrnt.sats \
  patsolve_parsing.sats \

######

SOURCES_DATS= \
  patsolve_main.dats \
  patsolve_mylib.dats \
  patsolve_commarg.dats \
  patsolve_cnstrnt.dats \
  patsolve_parsing.dats \

######

OBJECTS_SATS_O := \
  $(patsubst %.sats, %_sats.o, $(SOURCES_SATS))

OBJECTS_DATS_O := \
  $(patsubst %.dats, %_dats.o, $(SOURCES_DATS))

######

OBJECTS :=
OBJECTS += $(OBJECTS_SATS_O)
OBJECTS += $(OBJECTS_DATS_O)

######

PATSCC2 = $(PATSCC) $(CFLAGS)
PATSCC3 = $(PATSCC) $(CFLAGS) $(CFLAGS2)

######
#
all:: \
bin_patsolve
#
bin_patsolve: $(OBJECTS) ; \
$(PATSCC2) -O2 -o bin/patsolve $^ $(LDFLAGS) $(EXTRAFLAGS)
#
cleanall:: ; $(RMF) bin/patsolve
#
######

patsolve_main_dats.o: \
DATS/patsolve_main.dats; $(PATSCC2) -c $<

######

patsolve_mylib_dats.o: \
DATS/patsolve_mylib.dats; $(PATSCC3) -c $<

######

patsolve_commarg_sats.o: \
SATS/patsolve_commarg.sats; $(PATSCC) -c $<
patsolve_commarg_dats.o: \
DATS/patsolve_commarg.dats; $(PATSCC3) -c $<

######

patsolve_cnstrnt_sats.o: \
SATS/patsolve_cnstrnt.sats; $(PATSCC) -c $<
patsolve_cnstrnt_dats.o: \
DATS/patsolve_cnstrnt.dats; $(PATSCC2) -c $<

######

patsolve_parsing_sats.o: \
SATS/patsolve_parsing.sats; $(PATSCC3) -c $<
patsolve_parsing_dats.o: \
DATS/patsolve_parsing.dats; $(PATSCC3) -c $<

######
#
DATS_C:: \
DATS/patsolve_cnstrnt.dats; \
$(PATSOPT) -o CATS/patsolve_cnstrnt_dats.c --dynamic $<
DATS_C:: \
DATS/patsolve_parsing.dats; \
$(PATSOPT) -o CATS/patsolve_parsing_dats.c --dynamic $<
#
# cleanall:: ; $(RMF) CATS/patsolve_*_dats.c
#
######
#
-include .depend
#
depend:: ; $(RMF) .depend
#
ifeq ("$(strip $(SOURCES_SATS))","")
else
depend:: ; $(PATSOPT) --output-a .depend --depgen -s $(SOURCES_SATS)
endif
ifeq ("$(strip $(SOURCES_DATS))","")
else
depend:: ; $(PATSOPT) --output-a .depend --depgen -d $(SOURCES_DATS)
endif
#
######

testall:: all
testall:: DATS_C
testall:: cleanall

######

RMF=rm -f

######

cleanats:: ; $(RMF) *~
cleanats:: ; $(RMF) SATS/*~
cleanats:: ; $(RMF) DATS/*~
cleanats:: ; $(RMF) DATS/CNSTRNT/*~
cleanats:: ; $(RMF) DATS/PARSING/*~
cleanats:: ; $(RMF) *_?ats.o
cleanats:: ; $(RMF) *_?ats.c

######

clean: cleanats

######

cleanall:: cleanats
cleanall:: ; $(RMF) .depend

######

## end of [Makefile] ##

=== contrib/CATS-atscc2php/Makefile ===
#
# A simple Makefile
#

######

MAKE=make

######

PATSCC=$(PATSHOME)/bin/patscc
PATSOPT=$(PATSHOME)/bin/patsopt

######

all::

######

CATSPARSEMIT=./CATS-parsemit

######

SOURCES_DATS :=
SOURCES_DATS += DATS/atscc2php_main.dats
SOURCES_DATS += DATS/atscc2php_emit.dats
SOURCES_DATS += DATS/atscc2php_emit2.dats

SOURCES_SATS :=
SOURCES_SATS += $(CATSPARSEMIT)/SATS/catsparse.sats

SOURCES_CATS :=
SOURCES_CATS += $(CATSPARSEMIT)/CATS/catsparse_all_dats.c

######
#
all:: ; \
$(MAKE) -C CATS-parsemit all
#
######
#
all:: \
bin_atscc2php
bin_atscc2php: \
$(SOURCES_DATS); \
$(PATSCC) \
  -DATS_MEMALLOC_GCBDW -O2 -o bin/atscc2php \
  $(SOURCES_DATS) $(SOURCES_SATS) $(SOURCES_CATS) -lgc
#
######
#
npm:: bin_atscc2php
npm:: ; $(CPF) catsparse_sats.c atscc2php_*_dats.c npm/CATS/.
#
######

CPF=cp -f
RMF=rm -f

######
#
testall:: all
testall:: cleanall
#
######

clean:: ; $(RMF) *~
clean:: ; $(RMF) *_?ats.o
clean:: ; $(RMF) *_?ats.c

######
#
cleanall:: clean
#
cleanall:: ; $(RMF) ./bin/atscc2php
cleanall:: ; $(RMF) ./npm/CATS/catsparse_sats.c
cleanall:: ; $(RMF) ./npm/CATS/atscc2php_*_dats.c 
#
###### end of [Makefile] ######

=== contrib/CATS-atscc2scm/Makefile ===
#
# A simple Makefile
#

######

MAKE=make

######

PATSCC=$(PATSHOME)/bin/patscc
PATSOPT=$(PATSHOME)/bin/patsopt

######

all::

######

CATSPARSEMIT=./CATS-parsemit

######

SOURCES_DATS :=
SOURCES_DATS += DATS/atscc2scm_main.dats
SOURCES_DATS += DATS/atscc2scm_emit.dats
SOURCES_DATS += DATS/atscc2scm_emit2.dats

SOURCES_SATS :=
SOURCES_SATS += $(CATSPARSEMIT)/SATS/catsparse.sats

SOURCES_CATS :=
SOURCES_CATS += $(CATSPARSEMIT)/CATS/catsparse_all_dats.c

######
#
all:: ; \
$(MAKE) -C CATS-parsemit all
#
######
#
all:: \
bin_atscc2scm
bin_atscc2scm: \
$(SOURCES_DATS); \
$(PATSCC) \
  -DATS_MEMALLOC_GCBDW -O2 -o bin/atscc2scm \
  $(SOURCES_DATS) $(SOURCES_SATS) $(SOURCES_CATS) -lgc
#
######
#
npm:: bin_atscc2scm
npm:: ; $(CPF) catsparse_sats.c atscc2scm_*_dats.c npm/CATS/.
#
######

CPF=cp -f
RMF=rm -f

######
#
testall:: all
testall:: cleanall
#
######

clean:: ; $(RMF) *~
clean:: ; $(RMF) *_?ats.o
clean:: ; $(RMF) catsparse_sats.c
clean:: ; $(RMF) atscc2scm_*_?ats.c

######

cleanall:: clean
cleanall:: ; $(RMF) ./bin/atscc2scm

###### end of [Makefile] ######

=== src/CBOOT/Makefile ===
######
#
# The main Makefile for
# minimally C-bootstrapping ATS2
#
# 1. There is no GCATS by default
# 2. There is no dependency on libgmp
#
######
#
CC=gcc
GCC=gcc
CCOMP=$(CC)
#
# GCFLAG=-D_ATS_NGC
# GCFLAG=-D_ATS_GCBDW
# GCFLAG=-D_ATS_GCATS
#
# CFLAGS=
# LDFLAGS=
#
######

CFLAGS += -I. -I./ccomp/runtime

######
#
# This is fixed
#
C3NSTRINTKND=intknd
#
# [gmpknd] for CBOOTgmp
# [intknd] for CBOOTint
#
######
#
LIBGMP=
#
ifeq ($(C3NSTRINTKND),intknd)
LIBGMP :=
endif
ifeq ($(C3NSTRINTKND),gmpknd)
LIBGMP := -lgmp
endif
#
######
#
LIBGC=
gcats_o=
#
ifeq ($(GCFLAG),-D_ATS_GCBDW)
  LIBGC := -lgc
endif
ifeq ($(GCFLAG),-D_ATS_GCATS)
  gcats_o := gcats.o
endif
#
######

all:: patsopt

######

SOURCES := \
  pats_params.hats \
  pats_error.sats \
  pats_error.dats \
  pats_intinf.sats \
  pats_intinf.dats \
  pats_counter.sats \
  pats_counter.dats \
  pats_utils.sats \
  pats_utils.dats \
  pats_global.sats \
  pats_global.dats \
  pats_basics.sats \
  pats_basics.dats \
  pats_basics.hats \
  pats_stamp.sats \
  pats_stamp.dats \
  pats_symbol.sats \
  pats_symbol.dats \
  pats_filename.sats \
  pats_filename.dats \
  pats_location.sats \
  pats_location.dats \
  pats_location.cats \
  pats_jsonize.sats \
  pats_jsonize.dats \
  pats_errmsg.sats \
  pats_errmsg.dats \
  pats_reader.sats \
  pats_reader.dats \
  pats_reader.cats \
  pats_lexbuf.sats \
  pats_lexbuf.dats \
  pats_lexbuf.cats \
  pats_lexing.sats \
  pats_lexing.dats \
  pats_lexing.cats \
  pats_lexing_print.dats \
  pats_lexing_error.dats \
  pats_lexing_token.dats \
  pats_label.sats \
  pats_label.dats \
  pats_effect.sats \
  pats_effect.dats \
  pats_fixity.sats \
  pats_fixity_prec.dats \
  pats_fixity_fxty.dats \
  pats_syntax.sats \
  pats_syntax.dats \
  pats_syntax_print.dats \
  pats_depgen.sats \
  pats_depgen.dats \
  pats_taggen.sats \
  pats_taggen.dats \
  pats_tokbuf.sats \
  pats_tokbuf.dats \
  pats_tokbuf.cats \
  pats_parsing.sats \
  pats_parsing.dats \
  pats_parsing_error.dats \
  pats_parsing_util.dats \
  pats_parsing_kwds.dats \
  pats_parsing_base.dats \
  pats_parsing_e0xp.dats \
  pats_parsing_sort.dats \
  pats_parsing_staexp.dats \
  pats_parsing_p0at.dats \
  pats_parsing_dynexp.dats \
  pats_parsing_decl.dats \
  pats_parsing_toplevel.dats \
  pats_symmap.sats \
  pats_symmap.dats \
  pats_symmap_avltree.hats \
  pats_symmap_htlinprb.hats \
  pats_symenv.sats \
  pats_symenv.dats \
  pats_staexp1.sats \
  pats_staexp1.dats \
  pats_staexp1_print.dats \
  pats_dynexp1.sats \
  pats_dynexp1.dats \
  pats_dynexp1_print.dats \
  pats_trans1.sats \
  pats_trans1_env.sats \
  pats_trans1_env.dats \
  pats_e1xpval.sats \
  pats_e1xpval.dats \
  pats_e1xpval_error.dats \
  pats_filename_reloc.dats \
  pats_trans1_error.dats \
  pats_trans1_e0xp.dats \
  pats_trans1_effect.dats \
  pats_trans1_sort.dats \
  pats_trans1_staexp.dats \
  pats_trans1_p0at.dats \
  pats_trans1_syndef.dats \
  pats_trans1_dynexp.dats \
  pats_trans1_decl.dats \
  pats_staexp2.sats \
  pats_staexp2.dats \
  pats_stacst2.sats \
  pats_stacst2.dats \
  pats_staexp2_print.dats \
  pats_staexp2_pprint.dats \
  pats_staexp2_sort.dats \
  pats_staexp2_scst.dats \
  pats_staexp2_svar.dats \
  pats_staexp2_svvar.dats \
  pats_staexp2_hole.dats \
  pats_staexp2_ctxt.dats \
  pats_staexp2_dcon.dats \
  pats_staexp2_skexp.dats \
  pats_staexp2_szexp.dats \
  pats_staexp2_util.sats \
  pats_staexp2_util1.dats \
  pats_staexp2_util2.dats \
  pats_staexp2_util3.dats \
  pats_staexp2_error.sats \
  pats_staexp2_error.dats \
  pats_staexp2_solve.sats \
  pats_staexp2_solve.dats \
  pats_patcst2.sats \
  pats_patcst2.dats \
  pats_dynexp2.sats \
  pats_dynexp2.dats \
  pats_dyncst2.sats \
  pats_dyncst2.dats \
  pats_dynexp2_print.dats \
  pats_dynexp2_dcst.dats \
  pats_dynexp2_dvar.dats \
  pats_dynexp2_dmac.dats \
  pats_dynexp2_util.dats \
  pats_dynexp2_mapgen.dats \
  pats_codegen2.sats \
  pats_codegen2.dats \
  pats_codegen2_util.dats \
  pats_codegen2_absrec.dats \
  pats_codegen2_datype.dats \
  pats_codegen2_fprint.dats \
  pats_jsonize_synent2.sats \
  pats_jsonize_synent2.dats \
  pats_trans2.sats \
  pats_namespace.sats \
  pats_namespace.dats \
  pats_trans2_env.sats \
  pats_trans2_env.dats \
  pats_trans2_error.dats \
  pats_trans2_sort.dats \
  pats_trans2_staexp.dats \
  pats_trans2_p1at.dats \
  pats_trans2_dynexp.dats \
  pats_trans2_impdec.dats \
  pats_trans2_decl.dats \
  pats_dynexp3.sats \
  pats_dynexp3.dats \
  pats_dynexp3_print.dats \
  pats_trans3.sats \
  pats_trans3_error.dats \
  pats_trans3_util.dats \
  pats_trans3_env.sats \
  pats_trans3_env.dats \
  pats_trans3_env_print.dats \
  pats_trans3_env_scst.dats \
  pats_trans3_env_svar.dats \
  pats_trans3_env_termet.dats \
  pats_trans3_env_effect.dats \
  pats_trans3_env_dvar.dats \
  pats_trans3_env_lamlp.dats \
  pats_trans3_env_pfman.dats \
  pats_trans3_env_lstate.dats \
  pats_dmacro2.sats \
  pats_dmacro2.dats \
  pats_dmacro2_print.dats \
  pats_dmacro2_eval0.dats \
  pats_dmacro2_eval1.dats \
  pats_trans3_p2at.dats \
  pats_trans3_patcon.dats \
  pats_trans3_syncst.dats \
  pats_trans3_dynexp_up.dats \
  pats_trans3_dynexp_dn.dats \
  pats_trans3_appsym.dats \
  pats_trans3_caseof.dats \
  pats_trans3_selab.dats \
  pats_trans3_ptrof.dats \
  pats_trans3_viewat.dats \
  pats_trans3_deref.dats \
  pats_trans3_assgn.dats \
  pats_trans3_xchng.dats \
  pats_trans3_lvalres.dats \
  pats_trans3_fldfrat.dats \
  pats_trans3_looping.dats \
  pats_trans3_decl.dats \
  pats_lintprgm.sats \
  pats_lintprgm.dats \
  pats_lintprgm_print.dats \
  pats_lintprgm_myint.cats \
  pats_lintprgm_myint.dats \
  pats_lintprgm_solve.dats \
  pats_constraint3.sats \
  pats_constraint3.dats \
  pats_constraint3_print.dats \
  pats_constraint3_mapgen.dats \
  pats_constraint3_jsonize.dats \
  pats_constraint3_init.dats \
  pats_constraint3_simplify.dats \
  pats_constraint3_icnstr.dats \
  pats_constraint3_solve.dats \
  pats_histaexp.sats \
  pats_histaexp.dats \
  pats_histaexp_print.dats \
  pats_histaexp_funlab.dats \
  pats_hidynexp.sats \
  pats_hidynexp.dats \
  pats_hidynexp_print.dats \
  pats_hidynexp_util.dats \
  pats_typerase.sats \
  pats_typerase_error.dats \
  pats_typerase_staexp.dats \
  pats_typerase_dynexp.dats \
  pats_typerase_decl.dats \
  pats_ccomp.sats \
  pats_ccomp.dats \
  pats_ccomp_print.dats \
  pats_ccomp_hitype.dats \
  pats_ccomp_tmplab.dats \
  pats_ccomp_tmpvar.dats \
  pats_ccomp_d2env.dats \
  pats_ccomp_funlab.dats \
  pats_ccomp_funent.dats \
  pats_ccomp_util.dats \
  pats_ccomp_ccompenv.dats \
  pats_ccomp_instrseq.dats \
  pats_ccomp_hipat.dats \
  pats_ccomp_dynexp.dats \
  pats_ccomp_caseof.dats \
  pats_ccomp_claulst.dats \
  pats_ccomp_lazyeval.dats \
  pats_ccomp_trywith.dats \
  pats_ccomp_looping.dats \
  pats_ccomp_decl.dats \
  pats_ccomp_subst.dats \
  pats_ccomp_environ.dats \
  pats_ccomp_template.dats \
  pats_ccomp_emit.dats \
  pats_ccomp_emit2.dats \
  pats_ccomp_emit3.dats \
  pats_ccomp_main.dats \
  pats_comarg.sats \
  pats_comarg.dats \

######

SOURCESsta := $(filter %.sats, $(SOURCES))
SOURCESdyn := $(filter %.dats, $(SOURCES))

######

OBJECTSsta := $(SOURCESsta)
OBJECTSsta := $(patsubst %.sats, %_sats.o, $(OBJECTSsta))
OBJECTSdyn := $(SOURCESdyn)
OBJECTSdyn := $(patsubst %.dats, %_dats.o, $(OBJECTSdyn))

######

OBJECTSstadyn := $(OBJECTSsta) $(OBJECTSdyn)

######
#
patsopt: \
pats_main_dats.o \
$(OBJECTSstadyn) \
prelude_libats.o \
libc_libats.o libats_libats.o ; \
$(CCOMP) -O2 -I. $(GCFLAG) -o $@ \
  ccomp/runtime/ats_prelude.c $^ $(gcats_o) $(LDFLAGS) $(LIBGMP) $(LIBGC)
#
######
#
AR=ar
MV=mv
#
libatsopt: \
pats_main_none_dats.o \
$(OBJECTSstadyn) \
prelude_libats.o \
libc_libats.o libats_libats.o ; \
$(AR) -r libatsopt.a $^ $(gcats_o)
#
######
#
%_sats.o: %_sats.c ; $(CCOMP) -O2 $(CFLAGS) -c -o $@ $<
%_dats.o: %_dats.c ; $(CCOMP) -O2 $(CFLAGS) -c -o $@ $<
#
######

PRELUDE_OBJECTS := \
  prelude_basics_sta_sats.o \
  prelude_basics_dyn_sats.o \
  prelude_ats_main_prelude_dats.o \
  prelude_DATS_basics_dats.o \
  prelude_DATS_bool_dats.o \
  prelude_DATS_char_dats.o \
  prelude_DATS_float_dats.o \
  prelude_DATS_integer_dats.o \
  prelude_DATS_sizetype_dats.o \
  prelude_DATS_pointer_dats.o \
  prelude_DATS_reference_dats.o \
  prelude_DATS_string_dats.o \
  prelude_DATS_lazy_dats.o \
  prelude_DATS_lazy_vt_dats.o \
  prelude_DATS_printf_dats.o \
  prelude_DATS_filebas_dats.o \
  prelude_DATS_list_dats.o \
  prelude_DATS_list_vt_dats.o \
  prelude_DATS_list0_dats.o \
  prelude_DATS_option_dats.o \
  prelude_DATS_option_vt_dats.o \
  prelude_DATS_option0_dats.o \
  prelude_DATS_array_dats.o \
  prelude_DATS_array0_dats.o \
  prelude_DATS_matrix_dats.o \
  prelude_DATS_matrix0_dats.o \
  prelude_DATS_ptrarr_dats.o \
  prelude_DATS_unsafe_dats.o \

######
#
prelude_%.o: \
prelude/%.c ; $(CCOMP) $(CFLAGS) -c -o $@ $<
#
prelude_libats.o: $(PRELUDE_OBJECTS) ; ld -r -o $@ $^
#
######

LIBC_OBJECTS := \
  libc_SATS_errno_sats.o \
  libc_SATS_fcntl_sats.o \
  libc_DATS_fcntl_dats.o \
  libc_SATS_stdarg_sats.o \
  libc_SATS_stdio_sats.o \
  libc_SATS_stdlib_sats.o \
  libc_SATS_string_sats.o \
  libc_SATS_time_sats.o \
  libc_SATS_unistd_sats.o \
  libc_DATS_unistd_dats.o \
  libc_sys_SATS_stat_sats.o \
  libc_sys_SATS_wait_sats.o \
  libc_sys_SATS_types_sats.o \

ifeq ($(C3NSTRINTKND),gmpknd)
LIBC_OBJECTS += \
  libc_SATS_gmp_sats.o libc_DATS_gmp_dats.o
endif

######
#
libc_%.o: \
libc/%.c ; $(CCOMP) $(CFLAGS) -c -o $@ $<
#
libc_libats.o: $(LIBC_OBJECTS) ; ld -r -o $@ $^
#
######

LIBATS_OBJECTS := \
  libats_SATS_funmap_avltree_sats.o \
  libats_DATS_funmap_avltree_dats.o \
  libats_SATS_funset_avltree_sats.o \
  libats_DATS_funset_avltree_dats.o \
  libats_SATS_funset_listord_sats.o \
  libats_DATS_funset_listord_dats.o \
  libats_SATS_funmset_listord_sats.o \
  libats_DATS_funmset_listord_dats.o \
  libats_SATS_hashtable_chain_sats.o \
  libats_DATS_hashtable_chain_dats.o \
  libats_SATS_hashtable_linprb_sats.o \
  libats_DATS_hashtable_linprb_dats.o \
  libats_SATS_linqueue_arr_sats.o \
  libats_DATS_linqueue_arr_dats.o \
  libats_SATS_linqueue_lst_sats.o \
  libats_DATS_linqueue_lst_dats.o \
  libats_ngc_SATS_deque_arr_sats.o \
  libats_ngc_DATS_deque_arr_dats.o \

######
#
libats_%.o : \
libats/%.c ; $(CCOMP) $(CFLAGS) -c -o $@ $<
#
libats_libats.o: $(LIBATS_OBJECTS) ; ld -r -o $@ $^
#
######
#
gcats.o: \
  gcats1_hats gcats1_all_cats.o ; ld -r -o $@ gcats1_all_cats.o
#
gcats1_hats: ; \
  $(GCC) -E -P -o gcats1.hats -x c ./ccomp/runtime/GCATS/gcats1_master.hats
#
gcats1_all_cats.o: ; \
  $(CCOMP) -O2 -I. -I./ccomp/runtime -c -o $@ -x c ./ccomp/runtime/gcats1_all.cats
#
######

CPF=cp -f
RMF=rm -f

######
#
clean:: ; $(RMF) *~
clean:: ; $(RMF) *_sats.o
clean:: ; $(RMF) *_dats.o
#
clean:: ; $(RMF) gcats1.hats
clean:: ; $(RMF) gcats1_all_cats.o
#
clean:: ; $(RMF) gcats.o
clean:: ; $(RMF) patsopt
clean:: ; $(RMF) prelude_libats.o
clean:: ; $(RMF) libc_libats.o
clean:: ; $(RMF) libats_libats.o
#
######

cleanall:: clean

######

###### end of [Makefile_CBOOTint] ######

=== utils/atscc/Makefile ===
######
#
# A Simple Makefile
#
######

CPF=cp -f
RMF=rm -f
MAKE=make

######

copy:: ; \
$(CPF) DATS/*.?ats BUILD/.

######

build:: ; \
$(MAKE) \
-C BUILD -f ../Makefile_build

######
#
clean:: ; $(RMF) ./BUILD/*.o
clean:: ; $(RMF) ./BUILD/*.c
clean:: ; $(RMF) ./BUILD/*.?ats
#
######
#
cleanall:: clean
#
cleanall:: ; $(RMF) ./BUILD/patscc
#
######

###### end of [Makefile] ######

=== utils/myatscc/Makefile ===
######
#
# A Simple Makefile
#
######

CPF=cp -f
RMF=rm -f
MAKE=make

######

copy:: ; \
$(CPF) DATS/*.?ats BUILD/.

######

build:: ; \
$(MAKE) \
-C BUILD -f ../Makefile_build

######

testall:: ; \
$(MAKE) -C TEST testall 

######
#
clean:: ; $(RMF) ./BUILD/*.o
clean:: ; $(RMF) ./BUILD/*.c
clean:: ; $(RMF) ./BUILD/*.?ats
#
######
#
cleanall:: clean
#
cleanall:: ; $(RMF) ./BUILD/myatscc
#
######

###### end of [Makefile] ######

=== contrib/libatscc2py3/ATS2-0.3.2/Makefile ===
#
# For generating libatscc2py
#

######

PATSOPT=$(PATSHOME)/bin/patsopt
ATSCC2PY=$(PATSHOME)/bin/atscc2py3

######

CAT=cat
CPF=cp -f
RMF=rm -f
SCPR=scp -r

######
#
all:: ; \
$(PATSOPT) -d ./DATS/string.dats | \
$(ATSCC2PY) -o ./output/DATS/string_dats.py -i
#
######
#
all:: ; \
$(PATSOPT) -d ./DATS/PYlist.dats | \
$(ATSCC2PY) -o ./output/DATS/PYlist_dats.py -i
all:: ; \
$(PATSOPT) -d ./DATS/reference.dats | \
$(ATSCC2PY) -o ./output/DATS/reference_dats.py -i
#
all:: ; \
$(PATSOPT) -d ./DATS/list.dats | \
$(ATSCC2PY) -o ./output/DATS/list_dats.py -i
all:: ; \
$(PATSOPT) -d ./DATS/list_vt.dats | \
$(ATSCC2PY) -o ./output/DATS/list_vt_dats.py -i
#
all:: ; \
$(PATSOPT) -d ./DATS/option.dats | \
$(ATSCC2PY) -o ./output/DATS/option_dats.py -i
#
all:: ; \
$(PATSOPT) -d ./DATS/stream.dats | \
$(ATSCC2PY) -o ./output/DATS/stream_dats.py -i
all:: ; \
$(PATSOPT) -d ./DATS/stream_vt.dats | \
$(ATSCC2PY) -o ./output/DATS/stream_vt_dats.py -i
#
all:: ; \
$(PATSOPT) -d ./DATS/intrange.dats | \
$(ATSCC2PY) -o ./output/DATS/intrange_dats.py -i
#
all:: ; \
$(PATSOPT) -d ./DATS/arrayref.dats | \
$(ATSCC2PY) -o ./output/DATS/arrayref_dats.py -i
all:: ; \
$(PATSOPT) -d ./DATS/matrixref.dats | \
$(ATSCC2PY) -o ./output/DATS/matrixref_dats.py -i
#
######
#
all:: ; \
$(PATSOPT) -d ./DATS/funarray.dats | \
$(ATSCC2PY) -o ./output/DATS/funarray_dats.py -i
all:: ; \
$(PATSOPT) -d ./DATS/slistref.dats | \
$(ATSCC2PY) -o ./output/DATS/slistref_dats.py -i
all:: ; \
$(PATSOPT) -d ./DATS/qlistref.dats | \
$(ATSCC2PY) -o ./output/DATS/qlistref_dats.py -i
#
######

all:: ; \
$(PATSOPT) -d ./DATS/ML/list0.dats | \
$(ATSCC2PY) -o ./output/DATS/ML/list0_dats.py -i
all:: ; \
$(PATSOPT) -d ./DATS/ML/array0.dats | \
$(ATSCC2PY) -o ./output/DATS/ML/array0_dats.py -i
all:: ; \
$(PATSOPT) -d ./DATS/ML/option0.dats | \
$(ATSCC2PY) -o ./output/DATS/ML/option0_dats.py -i

######
#
LIBATSCC2PY3_ALL_PY=\
output/libatscc2py3_all.py
LIBATSCC2PY3_ALL_PYLIBC_PY=\
output/libatscc2py3_all_pylibc.py
LIBATSCC2PY3_ALL_PYGAME_PY=\
output/libatscc2py3_all_pygame.py
#
######

all_in_one:: libatscc2py3_all
all_in_one:: libatscc2py3_all_pylibc
all_in_one:: libatscc2py3_all_pygame

######
#
DATE=/bin/date
ECHO=/bin/echo -en
#
PRINTF=printf
#
######
#
# libatscc2py3_all:: ; \
# $(ECHO) '\n' | $(CAT) - >$(LIBATSCC2PY3_ALL_PY)
#
libatscc2py3_all:: ; \
$(PRINTF) '\n' | $(CAT) - >$(LIBATSCC2PY3_ALL_PY)
libatscc2py3_all:: ; \
$(PRINTF) '######\n' | $(CAT) - >>$(LIBATSCC2PY3_ALL_PY)
libatscc2py3_all:: ; \
$(PRINTF) '#\n' | $(CAT) - >>$(LIBATSCC2PY3_ALL_PY)
libatscc2py3_all:: ; \
$(PRINTF) '# Time of Generation:\n' | $(CAT) - >>$(LIBATSCC2PY3_ALL_PY)
libatscc2py3_all:: ; \
($(PRINTF) '# ' | $(CAT) - >>$(LIBATSCC2PY3_ALL_PY); $(DATE) | $(CAT) - >>$(LIBATSCC2PY3_ALL_PY))
libatscc2py3_all:: ; \
$(PRINTF) '#\n' | $(CAT) - >>$(LIBATSCC2PY3_ALL_PY)
libatscc2py3_all:: ; \
$(PRINTF) '######\n\n' | $(CAT) - >>$(LIBATSCC2PY3_ALL_PY)
#
######

libatscc2py3_all:: ; \
$(CAT) >>$(LIBATSCC2PY3_ALL_PY) \
CATS/basics_cats.py \
CATS/integer_cats.py \
CATS/bool_cats.py \
CATS/char_cats.py \
CATS/float_cats.py \
CATS/string_cats.py \
CATS/print_cats.py \
CATS/filebas_cats.py \
CATS/PYlist_cats.py \
CATS/reference_cats.py \

######

libatscc2py3_all:: ; \
$(CAT) >>$(LIBATSCC2PY3_ALL_PY) \
output/DATS/string_dats.py \
output/DATS/PYlist_dats.py \
output/DATS/reference_dats.py \
output/DATS/list_dats.py \
output/DATS/list_vt_dats.py \
output/DATS/option_dats.py \
output/DATS/stream_dats.py \
output/DATS/stream_vt_dats.py \
output/DATS/intrange_dats.py \
output/DATS/arrayref_dats.py \
output/DATS/matrixref_dats.py \
output/DATS/funarray_dats.py \
output/DATS/slistref_dats.py \
output/DATS/qlistref_dats.py \
output/DATS/ML/list0_dats.py \
output/DATS/ML/array0_dats.py \
output/DATS/ML/option0_dats.py \

######
#
libatscc2py3_all:: ; \
$(PRINTF) '\n' | $(CAT) - >>$(LIBATSCC2PY3_ALL_PY)
libatscc2py3_all:: ; \
$(PRINTF) '## ###### ###### ##' | $(CAT) - >>$(LIBATSCC2PY3_ALL_PY)
libatscc2py3_all:: ; \
$(PRINTF) '\n' | $(CAT) - >>$(LIBATSCC2PY3_ALL_PY)
#
libatscc2py3_all:: ; \
$(PRINTF) '\n## end of [libatscc2py3_all.py] ##\n' | $(CAT) - >>$(LIBATSCC2PY3_ALL_PY)
#
######

libatscc2py3_all_pylibc:: ; \
$(CAT) >$(LIBATSCC2PY3_ALL_PYLIBC_PY) \
CATS/PYLIBC_random_cats.py \
CATS/PYLIBC_datetime_cats.py \

######

libatscc2py3_all_pygame:: ; \
$(CAT) >$(LIBATSCC2PY3_ALL_PYGAME_PY) \
CATS/PYGAME_pygame_cats.py \

######

clean:: ; $(RMF) *~ */*~

######
#
cleanall:: clean
#
cleanall:: ; rm -rf output/__pycache__
#
cleanall:: ; $(RMF) output/DATS/*_?ats.py
cleanall:: ; $(RMF) output/DATS/ML/*_?ats.py
#
cleanall:: ; $(RMF) $(LIBATSCC2PY3_ALL_PY)
cleanall:: ; $(RMF) $(LIBATSCC2PY3_ALL_PYLIBC_PY)
cleanall:: ; $(RMF) $(LIBATSCC2PY3_ALL_PYGAME_PY)
#
###### end of [Makefile] ######

=== doc/EXAMPLE/ATSLIB/Makefile ===
#
#
# This Makefile is automatically generated
# from executing the following command-line:
#
# make -f Makefile.gen
#
#

######
#
CCOPT=gcc
#
# CCOPT=gcc -std=c99
#
######

ifeq ("$(PATSHOME)","")
  PATSHOMEQ="$(ATSHOME)"
else
  PATSHOMEQ="$(PATSHOME)"
endif

######

PATSOPT=$(PATSHOMEQ)/bin/patsopt
PATSLIB=$(PATSHOMEQ)/ccomp/atslib/lib

######

all::

######

LNS=ln -s
RMF=rm -f

######

all:: prelude_basics
prelude_basics: prelude_basics.exe
prelude_basics.exe: prelude_basics_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
prelude_basics_dats.c: prelude_basics.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_basics_dats.c --dynamic prelude_basics.dats
clean:: ; $(RMF) prelude_basics_dats.o
clean:: ; $(RMF) prelude_basics_dats.c
cleanall:: ; $(RMF) prelude_basics.exe


######

all:: prelude_integer
prelude_integer: prelude_integer.exe
prelude_integer.exe: prelude_integer_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_integer_dats.c: prelude_integer.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_integer_dats.c --dynamic prelude_integer.dats
clean:: ; $(RMF) prelude_integer_dats.o
clean:: ; $(RMF) prelude_integer_dats.c
cleanall:: ; $(RMF) prelude_integer.exe


######

all:: prelude_bool
prelude_bool: prelude_bool.exe
prelude_bool.exe: prelude_bool_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_bool_dats.c: prelude_bool.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_bool_dats.c --dynamic prelude_bool.dats
clean:: ; $(RMF) prelude_bool_dats.o
clean:: ; $(RMF) prelude_bool_dats.c
cleanall:: ; $(RMF) prelude_bool.exe

all:: prelude_char
prelude_char: prelude_char.exe
prelude_char.exe: prelude_char_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_char_dats.c: prelude_char.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_char_dats.c --dynamic prelude_char.dats
clean:: ; $(RMF) prelude_char_dats.o
clean:: ; $(RMF) prelude_char_dats.c
cleanall:: ; $(RMF) prelude_char.exe

all:: prelude_float
prelude_float: prelude_float.exe
prelude_float.exe: prelude_float_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -lm
prelude_float_dats.c: prelude_float.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_float_dats.c --dynamic prelude_float.dats
clean:: ; $(RMF) prelude_float_dats.o
clean:: ; $(RMF) prelude_float_dats.c
cleanall:: ; $(RMF) prelude_float.exe


######

all:: prelude_string
prelude_string: prelude_string.exe
prelude_string.exe: prelude_string_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -L$(PATSLIB) -latslib
prelude_string_dats.c: prelude_string.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_string_dats.c --dynamic prelude_string.dats
clean:: ; $(RMF) prelude_string_dats.o
clean:: ; $(RMF) prelude_string_dats.c
cleanall:: ; $(RMF) prelude_string.exe


######

all:: prelude_memory
prelude_memory: prelude_memory.exe
prelude_memory.exe: prelude_memory_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_memory_dats.c: prelude_memory.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_memory_dats.c --dynamic prelude_memory.dats
clean:: ; $(RMF) prelude_memory_dats.o
clean:: ; $(RMF) prelude_memory_dats.c
cleanall:: ; $(RMF) prelude_memory.exe

all:: prelude_pointer
prelude_pointer: prelude_pointer.exe
prelude_pointer.exe: prelude_pointer_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_pointer_dats.c: prelude_pointer.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_pointer_dats.c --dynamic prelude_pointer.dats
clean:: ; $(RMF) prelude_pointer_dats.o
clean:: ; $(RMF) prelude_pointer_dats.c
cleanall:: ; $(RMF) prelude_pointer.exe


######

all:: prelude_reference
prelude_reference: prelude_reference.exe
prelude_reference.exe: prelude_reference_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_reference_dats.c: prelude_reference.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_reference_dats.c --dynamic prelude_reference.dats
clean:: ; $(RMF) prelude_reference_dats.o
clean:: ; $(RMF) prelude_reference_dats.c
cleanall:: ; $(RMF) prelude_reference.exe


######

all:: prelude_filebas
prelude_filebas: prelude_filebas.exe
prelude_filebas.exe: prelude_filebas_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< -L$(PATSLIB) -latslib
prelude_filebas_dats.c: prelude_filebas.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_filebas_dats.c --dynamic prelude_filebas.dats
clean:: ; $(RMF) prelude_filebas_dats.o
clean:: ; $(RMF) prelude_filebas_dats.c
cleanall:: ; $(RMF) prelude_filebas.exe


######

all:: prelude_checkast
prelude_checkast: prelude_checkast.exe
prelude_checkast.exe: prelude_checkast_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2 -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -o $@ $<
prelude_checkast_dats.c: prelude_checkast.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_checkast_dats.c --dynamic prelude_checkast.dats
clean:: ; $(RMF) prelude_checkast_dats.o
clean:: ; $(RMF) prelude_checkast_dats.c
cleanall:: ; $(RMF) prelude_checkast.exe


######

all:: prelude_intrange
prelude_intrange: prelude_intrange.exe
prelude_intrange.exe: prelude_intrange_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_intrange_dats.c: prelude_intrange.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_intrange_dats.c --dynamic prelude_intrange.dats
clean:: ; $(RMF) prelude_intrange_dats.o
clean:: ; $(RMF) prelude_intrange_dats.c
cleanall:: ; $(RMF) prelude_intrange.exe


######

all:: prelude_list
prelude_list: prelude_list.exe
prelude_list.exe: prelude_list_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_list_dats.c: prelude_list.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_list_dats.c --dynamic prelude_list.dats
clean:: ; $(RMF) prelude_list_dats.o
clean:: ; $(RMF) prelude_list_dats.c
cleanall:: ; $(RMF) prelude_list.exe

all:: prelude_list_vt
prelude_list_vt: prelude_list_vt.exe
prelude_list_vt.exe: prelude_list_vt_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_list_vt_dats.c: prelude_list_vt.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_list_vt_dats.c --dynamic prelude_list_vt.dats
clean:: ; $(RMF) prelude_list_vt_dats.o
clean:: ; $(RMF) prelude_list_vt_dats.c
cleanall:: ; $(RMF) prelude_list_vt.exe


all:: prelude_option
prelude_option: prelude_option.exe
prelude_option.exe: prelude_option_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_option_dats.c: prelude_option.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_option_dats.c --dynamic prelude_option.dats
clean:: ; $(RMF) prelude_option_dats.o
clean:: ; $(RMF) prelude_option_dats.c
cleanall:: ; $(RMF) prelude_option.exe

all:: prelude_option_vt
prelude_option_vt: prelude_option_vt.exe
prelude_option_vt.exe: prelude_option_vt_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_option_vt_dats.c: prelude_option_vt.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_option_vt_dats.c --dynamic prelude_option_vt.dats
clean:: ; $(RMF) prelude_option_vt_dats.o
clean:: ; $(RMF) prelude_option_vt_dats.c
cleanall:: ; $(RMF) prelude_option_vt.exe


all:: prelude_array
prelude_array: prelude_array.exe
prelude_array.exe: prelude_array_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_array_dats.c: prelude_array.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_array_dats.c --dynamic prelude_array.dats
clean:: ; $(RMF) prelude_array_dats.o
clean:: ; $(RMF) prelude_array_dats.c
cleanall:: ; $(RMF) prelude_array.exe

all:: prelude_arrayptr
prelude_arrayptr: prelude_arrayptr.exe
prelude_arrayptr.exe: prelude_arrayptr_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_arrayptr_dats.c: prelude_arrayptr.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_arrayptr_dats.c --dynamic prelude_arrayptr.dats
clean:: ; $(RMF) prelude_arrayptr_dats.o
clean:: ; $(RMF) prelude_arrayptr_dats.c
cleanall:: ; $(RMF) prelude_arrayptr.exe

all:: prelude_arrayref
prelude_arrayref: prelude_arrayref.exe
prelude_arrayref.exe: prelude_arrayref_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_arrayref_dats.c: prelude_arrayref.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_arrayref_dats.c --dynamic prelude_arrayref.dats
clean:: ; $(RMF) prelude_arrayref_dats.o
clean:: ; $(RMF) prelude_arrayref_dats.c
cleanall:: ; $(RMF) prelude_arrayref.exe


all:: prelude_matrix
prelude_matrix: prelude_matrix.exe
prelude_matrix.exe: prelude_matrix_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_matrix_dats.c: prelude_matrix.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_matrix_dats.c --dynamic prelude_matrix.dats
clean:: ; $(RMF) prelude_matrix_dats.o
clean:: ; $(RMF) prelude_matrix_dats.c
cleanall:: ; $(RMF) prelude_matrix.exe

all:: prelude_matrixptr
prelude_matrixptr: prelude_matrixptr.exe
prelude_matrixptr.exe: prelude_matrixptr_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_matrixptr_dats.c: prelude_matrixptr.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_matrixptr_dats.c --dynamic prelude_matrixptr.dats
clean:: ; $(RMF) prelude_matrixptr_dats.o
clean:: ; $(RMF) prelude_matrixptr_dats.c
cleanall:: ; $(RMF) prelude_matrixptr.exe

all:: prelude_matrixref
prelude_matrixref: prelude_matrixref.exe
prelude_matrixref.exe: prelude_matrixref_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_matrixref_dats.c: prelude_matrixref.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_matrixref_dats.c --dynamic prelude_matrixref.dats
clean:: ; $(RMF) prelude_matrixref_dats.o
clean:: ; $(RMF) prelude_matrixref_dats.c
cleanall:: ; $(RMF) prelude_matrixref.exe


all:: prelude_stream
prelude_stream: prelude_stream.exe
prelude_stream.exe: prelude_stream_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_stream_dats.c: prelude_stream.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_stream_dats.c --dynamic prelude_stream.dats
clean:: ; $(RMF) prelude_stream_dats.o
clean:: ; $(RMF) prelude_stream_dats.c
cleanall:: ; $(RMF) prelude_stream.exe

all:: prelude_stream_vt
prelude_stream_vt: prelude_stream_vt.exe
prelude_stream_vt.exe: prelude_stream_vt_dats.c ;   $(CCOPT) -D_GNU_SOURCE -O2     -I$(PATSHOMEQ) -I$(PATSHOMEQ)/ccomp/runtime -DATS_MEMALLOC_LIBC -o $@ $< 
prelude_stream_vt_dats.c: prelude_stream_vt.dats ;   $(PATSOPT) -IATS$(PATSHOMEQ)/contrib --output prelude_stream_vt_dats.c --dynamic prelude_stream_vt.dats
clean:: ; $(RMF) prelude_stream_vt_dats.o
clean:: ; $(RMF) prelude_stream_vt_dats.c
cleanall:: ; $(RMF) prelude_stream_vt.exe


######

=== doc/EXAMPLE/INTRO/Makefile ===
#
# A simple Makefile
# for testing doc/EXAMPLE/INTRO
#

######

CCOMP=gcc

######

include $(PATSHOME)/share/atsmake-pre.mk

######

MYTARGET=MYTARGET
MYCCRULE=MYCCRULE

######

include $(PATSHOME)/share/atsmake-post.mk

######

PATSCCOMP=\
$(CCOMP) -D_XOPEN_SOURCE -I${PATSHOMEQ} -I${PATSHOMEQ}/ccomp/runtime

######

export PATSCCOMP

######

all:: acker1
all:: acker2
all:: acker3
all:: acker4
all:: areverse
all:: atof
all:: atoi
all:: bintree
all:: f91
all:: fact1
all:: fact2
all:: fact3
all:: fact_uninterp
all:: fcopy
all:: fcopy2
all:: fib1
all:: fib2
all:: fibmem
all:: fib_lazy
all:: fib_llazy
all:: fprintlst2
all:: fprtuple
all:: gfact
all:: hello
all:: intecho
all:: intrange
all:: linenmbr
all:: listfuns
all:: listpermute
all:: ordset
all:: sieve_lazy
all:: sieve_llazy
all:: staref
all:: strprefix
all:: tally

######

regress:: acker1 ; ./acker1 || (echo "$< failed" && exit 1)
regress:: acker2 ; ./acker2 || (echo "$< failed" && exit 1)
regress:: acker3 ; ./acker3 || (echo "$< failed" && exit 1)
regress:: acker4 ; ./acker4 || (echo "$< failed" && exit 1)
regress:: areverse ; ./areverse || (echo "$< failed" && exit 1)
regress:: atof ; ./atof || (echo "$< failed" && exit 1)
regress:: atoi ; ./atoi || (echo "$< failed" && exit 1)
regress:: bintree ; ./bintree || (echo "$< failed" && exit 1)
regress:: f91 ; ./f91 || (echo "$< failed" && exit 1)
regress:: fact1 fact1.test-cmp
	./$< 10 2>&1 | diff -q fact1.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: fact2 ; ./fact2 || (echo "$< failed" && exit 1)
regress:: fact3 ; ./fact3 || (echo "$< failed" && exit 1)
regress:: fact_uninterp fact_uninterp.test-cmp
	./$< 10 2>&1 | diff -q fact_uninterp.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: fcopy fcopy.test-inp fcopy.test-cmp
	./fcopy <fcopy.test-inp 2>&1 | diff -q fcopy.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: fcopy2 fcopy2.test-inp fcopy2.test-cmp
	./fcopy2 <fcopy2.test-inp 2>&1 | diff -q fcopy2.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: fib1 ; ./fib1 || (echo "$< failed" && exit 1)
regress:: fib2 ; ./fib2 || (echo "$< failed" && exit 1)
regress:: fibmem ; ./fibmem || (echo "$< failed" && exit 1)
regress:: fib_lazy ; ./fib_lazy || (echo "$< failed" && exit 1)
regress:: fib_llazy ; ./fib_llazy || (echo "$< failed" && exit 1)
regress:: fprintlst2 fprintlst2.test-cmp
	./$< 10 2>&1 | diff -q fprintlst2.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: fprtuple fprtuple.test-cmp
	./$< 10 2>&1 | diff -q fprtuple.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: gfact gfact.test-cmp
	./$< 10 2>&1 | diff -q gfact.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: hello hello.test-cmp
	./$< 10 2>&1 | diff -q hello.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: intecho intecho.test-inp intecho.test-cmp
	./intecho <intecho.test-inp 2>&1 | diff -q intecho.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: intrange ; ./intrange
regress:: linenmbr linenmbr.test-inp linenmbr.test-cmp
	./linenmbr <linenmbr.test-inp 2>&1 | diff -q linenmbr.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: listfuns ; ./listfuns || (echo "$< failed" && exit 1)
regress:: listpermute listpermute.test-cmp
	./$< 10 2>&1 | diff -q listpermute.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: ordset ordset.test-cmp
	./$< 10 2>&1 | diff -q ordset.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: sieve_lazy sieve_lazy.test-cmp
	./$< 10 2>&1 | diff -q sieve_lazy.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: sieve_llazy sieve_llazy.test-cmp
	./$< 10 2>&1 | diff -q sieve_llazy.test-cmp - >/dev/null || \
	(echo "$< failed" && exit 1)
regress:: staref ; ./staref || (echo "$< failed" && exit 1)
regress:: strprefix ; ./strprefix || (echo "$< failed" && exit 1)
regress:: tally ; ./tally || (echo "$< failed" && exit 1)

######

cleanall:: ; $(RMF) acker1
cleanall:: ; $(RMF) acker2
cleanall:: ; $(RMF) acker3
cleanall:: ; $(RMF) acker4
cleanall:: ; $(RMF) areverse
cleanall:: ; $(RMF) atof
cleanall:: ; $(RMF) atoi
cleanall:: ; $(RMF) bintree
cleanall:: ; $(RMF) f91
cleanall:: ; $(RMF) fact1
cleanall:: ; $(RMF) fact2
cleanall:: ; $(RMF) fact3
cleanall:: ; $(RMF) fact_uninterp
cleanall:: ; $(RMF) fcopy
cleanall:: ; $(RMF) fcopy2
cleanall:: ; $(RMF) fib1
cleanall:: ; $(RMF) fib2
cleanall:: ; $(RMF) fibmem
cleanall:: ; $(RMF) fib_lazy
cleanall:: ; $(RMF) fib_llazy
cleanall:: ; $(RMF) fprintlst2
cleanall:: ; $(RMF) fprtuple
cleanall:: ; $(RMF) gfact
cleanall:: ; $(RMF) hello
cleanall:: ; $(RMF) intecho
cleanall:: ; $(RMF) intrange
cleanall:: ; $(RMF) linenmbr
cleanall:: ; $(RMF) listfuns
cleanall:: ; $(RMF) listpermute
cleanall:: ; $(RMF) ordset
cleanall:: ; $(RMF) sieve_lazy
cleanall:: ; $(RMF) sieve_llazy
cleanall:: ; $(RMF) staref
cleanall:: ; $(RMF) strprefix
cleanall:: ; $(RMF) tally

######

testall:: all
testall:: regress
testall:: cleanall

######

acker1: acker1.dats ; $(PATSCC) -o $@ $<
acker2: acker2.dats ; $(PATSCC) -o $@ $<
acker3: acker3.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<
acker4: acker4.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

areverse: areverse.dats ; \
  $(PATSCC) -D_ATS_EXCEPTION_NONE -DATS_MEMALLOC_LIBC -o $@ $<

######

atof: acker1.dats ; $(PATSCC) -o $@ $<
atoi: acker1.dats ; $(PATSCC) -o $@ $<

######

bintree: bintree.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

f91: f91.dats ; $(PATSCC) -o $@ $<

######
#
fact1: fact1.dats ; $(PATSCC) -o $@ $<
fact2: fact2.dats ; $(PATSCC) -o $@ $<
fact3: fact3.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<
#
fact_uninterp: fact_uninterp.dats ; $(PATSCC) -o $@ $<
#
######

fcopy: fcopy.dats ; $(PATSCC) -o $@ $<
fcopy2: fcopy2.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $< myatslib.dats

######

fib1: fib1.dats ; $(PATSCC) -o $@ $<
fib2: fib2.dats ; $(PATSCC) -o $@ $<
fibmem: fibmem.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

fib_lazy: fib_lazy.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<
fib_llazy: fib_llazy.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

fprintlst2: fprintlst2.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

fprtuple: fprtuple.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

gfact: gfact.dats ; $(PATSCC) -o $@ $<

######

hello: hello.dats ; $(PATSCC) -o $@ $<

######

intecho: intecho.dats ; $(PATSCC) -o $@ $<

######

intrange: intrange.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

linenmbr: linenmbr.dats ; \
  $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $< myatslib.dats

######

listfuns: listfuns.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

listpermute: listpermute.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

ordset: ordset.dats ; $(PATSCC) -DATS_MEMALLOC_LIBC -o $@ $<

######

sieve_lazy: sieve_lazy.dats ; \
  $(PATSCC) -D_GNU_SOURCE -DATS_MEMALLOC_GCBDW -O2 -o $@ $< -lgc

sieve_llazy: sieve_llazy_dats.c ; \
  $(PATSCC) -cleanaft -D_GNU_SOURCE -DATS_MEMALLOC_LIBC -O2 -o $@ $<
sieve_llazy_dats.c: sieve_llazy.dats ; $(PATSCC) -ccats $<

######

staref: staref.dats ; $(PATSCC) -o $@ $<

######

strprefix: strprefix.dats ; $(PATSCC) -o $@ $<

######

tally: tally.dats ; $(PATSCC) -D_ATS_EXCEPTION_NONE -o $@ $<

######

cleanats:: ; $(RMF) *_?ats.c

###### end of [Makefile] ######

=== debian/changelog ===
ats2-lang (0.4.2-3) unstable; urgency=medium

  * No change source-only upload for testing migration (Closes: #1082929)

 -- Matthew Danish <mrd@debian.org>  Thu, 31 Oct 2024 13:13:33 +0000

ats2-lang (0.4.2-2) unstable; urgency=medium

  * Fix certain function prototypes (h/t Arvind Sedererdj) (Closes: #1066211).
  * Rebuild against newer dh-elpa (Closes: #1077094).
  * Remove usage of deprecated cl package from ats2-mode. 
  * Resolve ambiguous name of elisp package in favour of name 'ats2-mode'. 

 -- Matthew Danish <mrd@debian.org>  Tue, 06 Aug 2024 09:34:29 +0000

ats2-lang (0.4.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * source only upload to enable migration (Closes: #1006624)

 -- Paul Gevers <elbrus@debian.org>  Mon, 28 Feb 2022 21:22:33 +0100

ats2-lang (0.4.2-1) unstable; urgency=medium

  * New upstream release.

 -- Matthew Danish <mrd@debian.org>  Sun, 26 Dec 2021 11:47:52 +0000

=== debian/control ===
Source: ats2-lang
Section: devel
Priority: optional
Maintainer: Matthew Danish <mrd@debian.org>
Build-Depends: debhelper (>= 13.0), libgmp-dev, dh-elpa (>= 0.0.17)
Standards-Version: 4.7.0
Homepage: http://www.ats-lang.org/

Package: ats2-lang
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgc-dev
Description: ATS version 2 programming language compiler
 ATS2 a.k.a. ATS/Postiats is a programming language with a highly expressive
 type system rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Postiats) is written in ATS (ATS/Anairiats) itself.
 It can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains the compiler patsopt and the frontend patscc.

Package: elpa-ats2-mode
Architecture: all
Section: lisp
Depends: ${misc:Depends}, ${elpa:Depends}
Built-Using: ${misc:Built-Using}
Recommends: emacs (>= 46.0)
Enhances: emacs, emacs24, emacs25
Description: ATS version 2 programming language emacs mode
 ATS2 a.k.a. ATS/Postiats is a programming language with a highly expressive
 type system rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Postiats) is written in ATS (ATS/Anairiats) itself.
 It can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 This package contains the emacs mode for ATS2.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@  --no-parallel --with elpa

override_dh_auto_install:
	dh_auto_install --destdir debian/ats2-lang
	find debian/ats2-lang -name .keeper -exec rm \{\} \;
	# For now, until there is a flycheck package
	rm -f debian/ats2-lang/usr/share/emacs/site-lisp/ats2-mode/flycheck-ats2.el
	find debian/ats2-lang -wholename '*TEST/Worker*' -delete
	find debian/ats2-lang -wholename '*TEST/Counter*' -delete
	find debian/ats2-lang -name 'theDeclpostamble.html' -delete
	find debian/ats2-lang -name 'rpc_client.html' -delete
	find debian/ats2-lang -name 'test_client.html' -delete
	find debian/ats2-lang -name 'test2_client.html' -delete
	find debian/ats2-lang -name 'test3_client.html' -delete
	find debian/ats2-lang -wholename '*/contrib/*/README*' -delete
	find debian/ats2-lang -wholename '*/contrib/*/LICENSE*' -delete
	find debian/ats2-lang -type d -empty -delete
	mkdir -p debian/ats2-lang/usr/share/doc/ats2-lang
	cp CHANGES-ats2 debian/ats2-lang/usr/share/doc/ats2-lang/changelog
	gzip -9 debian/ats2-lang/usr/share/doc/ats2-lang/changelog
	# fix problem with symlinks from upstream package:
	find debian/ats2-lang/usr/lib/ats2-postiats-*/contrib -name Makefile.gen -exec ln -sf  ../../../../../share/Makefile.gen \{\} \;

override_dh_clean:
	dh_clean
	rm -f src/CBOOT/libatsopt.a
